package cn.com.ctop.kuaishou.modules.batch.controller;

import cn.com.ctop.kuaishou.modules.batch.entity.KuaiShouTitleCollection;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaiShouTitleCollectionService;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * 标题收藏
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2020-07-22
 */
@Slf4j
@Api(tags = "标题收藏")
@RestController
@RequestMapping("/kuaishou/kuaiShouTitleCollection")
public class KuaiShouTitleCollectionController {
    @Autowired
    private IKuaiShouTitleCollectionService kuaiShouTitleCollectionService;

    /**
     * 分页列表查询
     *
     * @param kuaiShouTitleCollection
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    @AutoLog(value = "标题收藏-分页列表查询")
    @ApiOperation(value = "标题收藏-分页列表查询", notes = "标题收藏-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<KuaiShouTitleCollection>> queryPageList(KuaiShouTitleCollection kuaiShouTitleCollection,
                                                                @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                                @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                                HttpServletRequest req) {
        Result<IPage<KuaiShouTitleCollection>> result = new Result<>();
        QueryWrapper<KuaiShouTitleCollection> queryWrapper = QueryGenerator.initQueryWrapper(kuaiShouTitleCollection, req.getParameterMap());
        queryWrapper.orderByDesc("create_time");
        Page<KuaiShouTitleCollection> page = new Page<>(pageNo, pageSize);
        IPage<KuaiShouTitleCollection> pageList = kuaiShouTitleCollectionService.page(page, queryWrapper);
        result.setSuccess(true);
        result.setResult(pageList);
        return result;

    }

    /**
     * 添加
     *
     * @param kuaiShouTitleCollection
     * @return
     */
    @AutoLog(value = "标题收藏-添加")
    @ApiOperation(value = "标题收藏-添加", notes = "标题收藏-添加")
    @PostMapping(value = "/add")
    public Result<KuaiShouTitleCollection> add(@RequestBody KuaiShouTitleCollection kuaiShouTitleCollection) {
        Result<KuaiShouTitleCollection> result = new Result<>();
        try {
            kuaiShouTitleCollectionService.save(kuaiShouTitleCollection);
            result.success("添加成功！");
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            result.error500("操作失败");
        }
        return result;
    }

    /**
     * 添加
     *
     * @param kuaiShouTitleCollection
     * @return
     */
    @PostMapping(value = "/addMore")
    public Result<KuaiShouTitleCollection> addMore(@RequestBody JSONObject data) {
        Result<KuaiShouTitleCollection> result = new Result<>();
        try {
            JSONArray titles = data.getJSONArray("titles");
            KuaiShouTitleCollection kuaiShouTitleCollection = JSONObject.parseObject(data.toJSONString(), KuaiShouTitleCollection.class);
            for (Object title : titles) {
                kuaiShouTitleCollection.setTitle(title.toString());
                kuaiShouTitleCollectionService.save(kuaiShouTitleCollection);
            }
            result.success("添加成功！");
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            result.error500("操作失败");
        }
        return result;
    }

    /**
     * 编辑
     *
     * @param kuaiShouTitleCollection
     * @return
     */
    @AutoLog(value = "标题收藏-编辑")
    @ApiOperation(value = "标题收藏-编辑", notes = "标题收藏-编辑")
    @PutMapping(value = "/edit")
    public Result<KuaiShouTitleCollection> edit(@RequestBody KuaiShouTitleCollection kuaiShouTitleCollection) {
        Result<KuaiShouTitleCollection> result = new Result<KuaiShouTitleCollection>();
        KuaiShouTitleCollection kuaiShouTitleCollectionEntity = kuaiShouTitleCollectionService.getById(kuaiShouTitleCollection.getId());
        if (kuaiShouTitleCollectionEntity == null) {
            result.error500("未找到对应实体");
        } else {
            boolean ok = kuaiShouTitleCollectionService.updateById(kuaiShouTitleCollection);
            if (ok) {
                result.success("修改成功!");
            }
        }

        return result;
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "标题收藏-通过id删除")
    @ApiOperation(value = "标题收藏-通过id删除", notes = "标题收藏-通过id删除")
    @DeleteMapping(value = "/delete")
    public Result<?> delete(@RequestParam(name = "id", required = true) String id) {
        try {
            kuaiShouTitleCollectionService.removeById(id);
        } catch (Exception e) {
            log.error("删除失败", e.getMessage());
            return Result.error("删除失败!");
        }
        return Result.ok("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "标题收藏-批量删除")
    @ApiOperation(value = "标题收藏-批量删除", notes = "标题收藏-批量删除")
    @DeleteMapping(value = "/deleteBatch")
    public Result<KuaiShouTitleCollection> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        Result<KuaiShouTitleCollection> result = new Result<>();
        if (ids == null || "".equals(ids.trim())) {
            result.error500("参数不识别！");
        } else {
            this.kuaiShouTitleCollectionService.removeByIds(Arrays.asList(ids.split(",")));
            result.success("删除成功!");
        }
        return result;
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    @AutoLog(value = "标题收藏-通过id查询")
    @ApiOperation(value = "标题收藏-通过id查询", notes = "标题收藏-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<KuaiShouTitleCollection> queryById(@RequestParam(name = "id", required = true) String id) {
        Result<KuaiShouTitleCollection> result = new Result<>();
        KuaiShouTitleCollection kuaiShouTitleCollection = kuaiShouTitleCollectionService.getById(id);
        if (kuaiShouTitleCollection == null) {
            result.error500("未找到对应实体");
        } else {
            result.setResult(kuaiShouTitleCollection);
            result.setSuccess(true);
        }
        return result;
    }

    /**
     * 导出excel
     *
     * @param request
     * @param response
     */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
        // Step.1 组装查询条件
        QueryWrapper<KuaiShouTitleCollection> queryWrapper = null;
        try {
            String paramsStr = request.getParameter("paramsStr");
            if (oConvertUtils.isNotEmpty(paramsStr)) {
                String deString = URLDecoder.decode(paramsStr, "UTF-8");
                KuaiShouTitleCollection kuaiShouTitleCollection = JSON.parseObject(deString, KuaiShouTitleCollection.class);
                queryWrapper = QueryGenerator.initQueryWrapper(kuaiShouTitleCollection, request.getParameterMap());
            }
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }

        //Step.2 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        List<KuaiShouTitleCollection> pageList = kuaiShouTitleCollectionService.list(queryWrapper);
        //导出文件名称
        mv.addObject(NormalExcelConstants.FILE_NAME, "标题收藏列表");
        mv.addObject(NormalExcelConstants.CLASS, KuaiShouTitleCollection.class);
        mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("标题收藏列表数据", "导出人:Jeecg", "导出信息"));
        mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
        return mv;
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
        Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
        for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
            MultipartFile file = entity.getValue();
            ImportParams params = new ImportParams();
            params.setTitleRows(2);
            params.setHeadRows(1);
            params.setNeedSave(true);
            try {
                List<KuaiShouTitleCollection> listKuaiShouTitleCollections = ExcelImportUtil.importExcel(file.getInputStream(), KuaiShouTitleCollection.class, params);
                kuaiShouTitleCollectionService.saveBatch(listKuaiShouTitleCollections);
                return Result.ok("文件导入成功！数据行数:" + listKuaiShouTitleCollections.size());
            } catch (Exception e) {
                log.error(e.getMessage(), e);
                return Result.error("文件导入失败:" + e.getMessage());
            } finally {
                try {
                    file.getInputStream().close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return Result.ok("文件导入失败！");
    }

}
